# KunDB部署实施规范检测工具

## 使用说明
脚本工具支持检测TDC和TDH环境
- KunDB实施规范标准请参照https://doc.weixin.qq.com/sheet/e3_ADYAqAYTAKg8bhsAp0eQfC9x4bfcQ?scode=ABoAuwfGAAkSs1S0DTADYAqAYTAKg&tab=w0j8k9
- TDC支持TDC3.X（TOS3.X）及以上版本，TDH环境无版本要求
- node_check.sh用于检测节点性能,运行前需要安装好TOS，且在master节点执行。<font color="#dd0000">执行前需要确认环境没有在进行高IO任务执行，否则会影响任务。</font><br /> 
- kundb_check.sh用于检测kundb状态和参数,只支持KunDB3.1.x以上版本，在安装完KunDB实例后执行

### TDC环境
1. 进入tdc目录
```bash
cd tdc/
```
2. 需要先配置hosts.txt，填写节点hosts信息和root密码
3. 执行节点性能检测，执行结果请查看all-nodes.csv
```bash
sh node_check.sh
```
4. 执行kundb参数检测，执行结果请查看kundb_check_clus-xx.csv
```bash
sh kundb_check.sh {ip} {kungate-nodeport}
#例如sh -x kundb_check.sh 172.16.124.11 31393
```
5.kundb参数检测结果kundb_check_clus-xx.csv文件为GBK编码，需要用windows excel打开。linux环境需要修改kundb_check.sh脚本
```bash
iconv -f UTF-8 -t UTF-8 $kundb_check_result -o kundb_check_$get_current_kungate_project_label.csv
```


### TDH环境
```bash
cd tdh/
```
2. 需要先配置hosts.txt，填写节点hosts信息和root密码
3. 执行节点性能检测，执行结果请查看all-nodes.csv
```bash
sh node_check.sh
```
4. 执行kundb参数检测，执行结果请查看kundb_check.csv
```bash
sh kundb_check.sh {ip} {kungate.server.port} {user} {password}
#例如sh  kundb_check.sh 172.18.20.158 15307 vt_app Transwarp#123
```
5.kundb参数检测结果kundb_check.csv文件为GBK编码，需要用windows excel打开。linux环境需要修改kundb_check.sh脚本
```bash
iconv -f UTF-8 -t UTF-8 $kundb_check_result -o kundb_check.csv
```
6.如果有多个实例，需要修改脚本中kungate_debug_port端口配置