#!/bin/bash

echo "--------(begin)--------" 

if [ -f "all-nodes.csv" ]; then
  mv all-nodes.csv /tmp/
fi


function check_hosts_exsits()
{
fail_count=0
while read line || [[ -n ${line} ]]
do
  ipaddr=$(echo $line | awk '{print $1}')
  ipaddr_hosts_exist=`cat /etc/hosts |grep $ipaddr |wc -l`
  if [  $ipaddr_hosts_exist -eq 0  ];then
     echo "Node $ipaddr not found in /etc/hosts, maybe not this cluster's node" 
     fail_count=`expr $fail_count + 1`
  fi
done < hosts.txt

if [ $fail_count -gt 0 ];then
   echo "ERROR: The  shell script exit execute. please check node ip in hosts.txt first!"
   exit 1
fi
}
check_hosts_exsits

function check_root_passwd()
{
fail_count=0
while read line || [[ -n ${line} ]]
do
  ip=$(echo $line | awk '{print $1}')
  passwd=$(echo $line | awk '{print $2}')
  
  sshpass -p ${passwd} ssh -o StrictHostKeyChecking=no root@${ip} "exit"
  if [ $? -ne 0 ];then
  echo "node $ip password is not correct"
  fail_count=`expr $fail_count + 1`
  fi
done < hosts.txt

if [ $fail_count -gt 0 ];then
   echo "ERROR: The  shell script exit execute. please check node password in hosts.txt first!"
   exit 1
fi
}
check_root_passwd


#get  node subpool device
kubectl get wp --output=custom-columns='NAME:.metadata.name,NODE:.spec.nodeId,SUBPOOL:.spec.name,DISKS:.spec.blkDevice' | awk '{print $2" "$4}' > check_disk_list


while read line || [[ -n ${line} ]]
do
  ip=$(echo $line | awk '{print $1}')
  passwd=$(echo $line | awk '{print $2}')

  sshpass -p "$passwd" scp -o 'StrictHostKeyChecking=no' node_pre.sh $ip:/tmp
  sshpass -p "$passwd" scp -o 'StrictHostKeyChecking=no' check_disk_list $ip:/tmp
  sshpass -p "$passwd" scp -o 'StrictHostKeyChecking=no' ../tools/iperf $ip:/tmp
  sshpass -p "$passwd" ssh $ip "bash /tmp/node_pre.sh;" < /dev/null
  sshpass -p "$passwd" ssh $ip "echo $ip;cat /tmp/result.csv;" >> all-nodes.csv < /dev/null
  sshpass -p "$passwd" ssh $ip "rm -rf  /tmp/result.csv;" < /dev/null
  sshpass -p "$passwd" ssh $ip "rm -rf  /tmp/node_pre.sh;" < /dev/null
  sshpass -p "$passwd" ssh $ip "rm -rf  /tmp/check_disk_list;" < /dev/null
  echo $ip

echo "--------(end)--------"
done < hosts.txt
rm -f check_disk_list


echo "The kundb pre check result has been output to all-nodes.csv"
echo "---------------------"