#!/bin/bash 

export LANG=en_US.UTF-8

temporary_cache_file=temporary-cache
fail_count=0

cd /tmp 
if [ -f "result.csv" ]; then
  rm -rf result.csv
fi


#according hostname to get check disk list
function get_check_disk_list()
{
cat /dev/null > /tmp/disk_list
cat /tmp/check_disk_list | grep -w `hostname` | awk '{print $2}' > /tmp/disk_cache_list
while read line
do
subpool_disk_name=${line/[/}
subpool_disk_name=${subpool_disk_name/]/}
echo $subpool_disk_name >> /tmp/disk_list
done < /tmp/disk_cache_list
rm -rf  /tmp/disk_cache_list
}
get_check_disk_list




echo "check options,current result,expected status,if OK,suppose to do" >> /tmp/result.csv
#check the total memory and cpu cores number
CheckMemoryCpu(){
total_memory=`free -mh | head -n 2 |tail -n 1 |awk '{print$2}'`

  if [[ ${total_memory%*${total_memory:(-1)}} -ge 64 ]];then
    echo "Total memory,$total_memory,>= 64G,yes" >> /tmp/result.csv
  else
    echo "Total memory,$total_memory,>= 64G,no,memory is not enough" >> /tmp/result.csv
    fail_count=`expr $fail_count + 1`
  fi

cpu=`lscpu | head -n 4 | tail -n 1 | awk '{print $2}'`
total_cpu="$cpu"
  if [ $total_cpu -ge 32 ];then
    echo "Total cpu,$total_cpu,>= 32,yes">> /tmp/result.csv
  else
    echo "Total cpu,$total_cpu,>= 32,no,cpu is not enough" >> /tmp/result.csv
    fail_count=`expr $fail_count + 1`
  fi
}

function get_root_path_disk_usage()
{
usage_num=`df -h | awk '$6=="/"{sub("%","",$5);print $5}'`
usage=`df -h | awk '$6=="/"{sub("",$5);print $5}'`
if [ $usage_num  -gt 60  ];then
  echo "/ mountpoint usage,$usage,<=60%,no,root mountpoint usage must be <=60%" >> /tmp/result.csv
  fail_count=`expr $fail_count + 1`
else
  echo "/ mountpoint usage,$usage,<=60%,yes" >> /tmp/result.csv
fi
}

CheckNetworkPerformance(){
temporary_hostname=`hostname`
#get a Bandwidth and pps string rype then cut the string to get the number
cd /tmp
./iperf -c $temporary_hostname -p 10000 -u -t 5 -i 1 -l 16 -b 80000kpps -e 2>&1 | grep '0.00-5.00' | awk -F ' ' '{print $7" "$8" "$10" "$11}' > Network_item
#use Bandwidth_item to  avoid decimal calculations
Bandwidth_item=`cat Network_item | awk '{print $1}' |awk -F '.' '{print $1}'`
Bandwidth_result=`cat Network_item | awk '{print $1 $2}'`
  if [[ $Bandwidth_item -ge 40  ]];then
    echo "Network Bandwidth,$Bandwidth_result,>=40Mbits/sec,yes" >> /tmp/result.csv 
  else
    echo "Network Bandwidth,$Bandwidth_result,>=40Mbits/sec,no,Bandwidth speed it is not wide enough" >> /tmp/result.csv
    fail_count=`expr $fail_count + 1`
  fi
#get the pps result
pps_item=`cat Network_item | awk '{print $3}'`
  if [[ $pps_item -ge 400000 ]];then
    echo "Network pps,$pps_item pps,>=400000 pps,yes" >> /tmp/result.csv
  else
    echo "Network pps,$pps_item pps,>=400000 pps,no,pps is lower than 400000" >> /tmp/result.csv
    fail_count=`expr $fail_count + 1`
  fi
  rm -rf Network_item
}

CheckDiskperformance(){
while read -r line || [[ -n ${line} ]]
do
    #read_speed=`dd if=$diskvar of=/dev/null bs=1M count=1024 iflag=direct  2>& 1 | tail -n 1 |cut -d "," -f3 |awk '{gsub(/ /,"")}1'`
    read_speed=`dd if=$line of=/dev/null bs=1M count=1024 iflag=direct  2>& 1 | tail -n 1 |awk -F ' ' '{print $8 $9}'`
    #write_speed=`dd if=$diskvar of=tempfile bs=1M count=1024  oflag=direct  2>& 1 | tail -n 1 |cut -d "," -f3 |awk '{gsub(/ /,"")}1'`
    write_speed=`dd if=$line of=tempfile  bs=64K count=4K  oflag=direct  2>& 1 | tail -n 1 |awk -F ' ' '{print $8 $9}'`
    
    #Get values and units
    read_speed_value=`echo $read_speed | tr -cd "^(([0-9]+\.[0-9]*[1-9][0-9]*)|([0-9]*[1-9][0-9]*\.[0-9]+)|([0-9]*[1-9][0-9]*))$"`
    read_speed_units=`echo ${read_speed##*$read_speed_value}`
    read_speed_num=`echo $read_speed_value | awk -F. '{print $1}'`
    write_speed_value=`echo $write_speed | tr -cd "^(([0-9]+\.[0-9]*[1-9][0-9]*)|([0-9]*[1-9][0-9]*\.[0-9]+)|([0-9]*[1-9][0-9]*))$"`
    write_speed_units=`echo ${write_speed##*$write_speed_value}`
    write_speed_num=`echo $write_speed_value | awk -F. '{print $1}'`

  #get the speed unit  if the unit is MB/s then check the current read and write speed if is ok,if unit is GB/s the it is fast enough
  if [ $read_speed_units = "GB/s" ];then
    read_speed_check=ok
  elif [ $read_speed_units = "KB/s" ];then
    read_speed_check=no
  elif [ $read_speed_units = "MB/s" ];then
     if  [[ ${read_speed_num} -ge 150 ]];then
     read_speed_check=ok
     else
     read_speed_check=no
     fi
  fi
  
  if [ $write_speed_units = "GB/s" ];then
    write_speed_check=ok
  elif [ $write_speed_units = "KB/s" ];then
    write_speed_check=no
  elif [ $write_speed_units = "MB/s" ];then
     if  [[ ${write_speed_num} -ge 200 ]];then
     write_speed_check=ok
     else
     write_speed_check=no
     fi
  fi
    
  if  [ $read_speed_check = "no" -o  $write_speed_check = "no" ];then
  disk_performance_check=no
  fail_count=`expr $fail_count + 1`
  else
  disk_performance_check=yes
  fi
  
  echo "$line performance,read speed $read_speed write speed $write_speed,read_speed >= 150MB/s write_speed >= 200MB/s,$disk_performance_check" >> /tmp/result.csv
  
done < /tmp/disk_list
rm -rf /tmp/tempfiles
}


CheckDiskType(){
while read line || [[ -n ${line} ]]
do
disk_only_name=`echo $line |cut -f3 -d '/'`
disk_algorithm_type=`lsblk -t |grep $disk_only_name |awk '{print $8}'`
if [ "${disk_algorithm_type}" = "deadline" ];then
    echo "$line Disk algorithm,$disk_algorithm_type,deadline,yes" >> /tmp/result.csv
else
    echo "$line Disk algorithm,$disk_algorithm_type,deadline,no,suggest to use deadline algorithm" >> /tmp/result.csv
    fail_count=`expr $fail_count + 1`
fi
done < /tmp/disk_list
}


CheckMemoryCpu
get_root_path_disk_usage
CheckDiskperformance
CheckNetworkPerformance
CheckDiskType


rm -f /tmp/check_disk_list
rm -r /tmp/disk_list


echo  " " >>/tmp/result.csv

if [ $fail_count = 0 ];then
    echo "=============all precheck items passed============="
else 
    echo "========there are $fail_count failed items,please check the all-nodes.csv to fix it========"
fi
